ncurses 5.7 - patch 20100925
authorThomas E. Dickey <dickey@invisible-island.net>
Sun, 26 Sep 2010 01:21:45 +0000 (01:21 +0000)
committerThomas E. Dickey <dickey@invisible-island.net>
Sun, 26 Sep 2010 01:21:45 +0000 (01:21 +0000)
+ add "XT" capability to entries for terminals that support both
  xterm-style mouse- and title-controls, for "screen" which
  special-cases TERM beginning with "xterm" or "rxvt" -TD
> patch by Juergen Pfeifer:
+ use 64-Bit MinGW toolchain (recommended package from TDM, see
  README.MinGW).
+ support pthreads when using the TDM MinGW toolchain

13 files changed:
MANIFEST
Makefile.in
NEWS
README.MinGW
configure
configure.in
dist.mk
include/Makefile.in
include/nc_mingw.h
misc/terminfo.src
mk-dlls.sh.in [moved from mk-dlls.sh with 88% similarity]
ncurses/trace/lib_trace.c
test/rain.c

index ed71f393fc408ccd87bda22ff2e9a9158d8b7272..b6c432c0027bd25d34a6f0e07e49dfc6258c4c7a 100644 (file)
--- a/MANIFEST
+++ b/MANIFEST
 ./mk-0th.awk
 ./mk-1st.awk
 ./mk-2nd.awk
-./mk-dlls.sh
+./mk-dlls.sh.in
 ./mk-hdr.awk
 ./ncurses/Makefile.in
 ./ncurses/README
index 304e929cbb4c75a74beed820b4439ee85890b7bb..499c0d69344d51c39292906424dd348df798a3d3 100644 (file)
@@ -1,4 +1,4 @@
-# $Id: Makefile.in,v 1.26 2010/03/27 23:21:03 tom Exp $
+# $Id: Makefile.in,v 1.28 2010/09/25 22:35:37 tom Exp $
 ##############################################################################
 # Copyright (c) 1998-2008,2010 Free Software Foundation, Inc.                #
 #                                                                            #
@@ -42,6 +42,9 @@ NCURSES_MAJOR = @NCURSES_MAJOR@
 NCURSES_MINOR  = @NCURSES_MINOR@
 NCURSES_PATCH  = @NCURSES_PATCH@
 
+top_srcdir     = @top_srcdir@
+srcdir         = @srcdir@
+
 prefix         = @prefix@
 exec_prefix    = @exec_prefix@
 
@@ -84,7 +87,11 @@ preinstall :
                echo '** Will overwrite non-ncurses curses.h'
 
 dlls:  libs
-       sh mk-dlls.sh
+       $(SHELL) $(srcdir)/mk-dlls.sh
+
+distclean \
+realclean ::
+       -rm -f mk-dlls.sh
 
 # Put the common rules here so that we can easily construct the list of
 # directories to visit.
diff --git a/NEWS b/NEWS
index 847017e9f6c468b9cdaa6be17a7dba09ccf3a973..c13d3e86a0a81f423e8de754d9f2dee936a9e312 100644 (file)
--- a/NEWS
+++ b/NEWS
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.1593 2010/09/18 22:53:08 tom Exp $
+-- $Id: NEWS,v 1.1595 2010/09/25 22:25:20 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,15 @@ See the AUTHORS file for the corresponding full names.
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20100925
+       + add "XT" capability to entries for terminals that support both
+         xterm-style mouse- and title-controls, for "screen" which
+         special-cases TERM beginning with "xterm" or "rxvt" -TD
+       > patch by Juergen Pfeifer:
+       + use 64-Bit MinGW toolchain (recommended package from TDM, see
+         README.MinGW).
+       + support pthreads when using the TDM MinGW toolchain
+
 20100918
        + regenerated html manpages.
        + minor fixes for symlinks to curs_legacy.3x and curs_slk.3x manpages.
index 6c0b9d620dfc6f9ba07db13d6f2cb831ede915f4..666e248095f53a81e15a0f34ec90d00b99f64bb9 100644 (file)
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: README.MinGW,v 1.1 2008/12/14 19:22:16 juergen Exp $
+-- $Id: README.MinGW,v 1.2 2010/09/25 22:16:12 juergen Exp $
 -- Author: Juergen Pfeifer
 -------------------------------------------------------------------------------
 
 This is work in progress, but it's in an state where one can see it
 works at least on the Windows Console.
 
-To build ncurses for native Windows, you need the MinGW toolchain from
-http://www.mingw.org
+You should install the MSYS package, so that you've a shell environment
+that allows you to run the scripts, especially configure etc. You can get
+that from http://www.mingw.org
 
-You should install also the MSYS package, so that you've a shell environment
-that allows you to run the scripts, especially configure etc.
+To build ncurses for native Windows, you need the MinGW toolchain. The
+original MinGW toolchain from above site is only for 32-Bit Windows. As
+Windows Server - and even more and more regular workstations - are moving
+to 64-Bit, it seems to be reasonable to have a toolchain that supports
+both architectures. I recommend to use the TDM gcc toolchain which you
+can find at http://tdm-gcc.tdragon.net/download. Go to the download section
+and select the bundle installer for tdm64 (MinGW-w64). This installs a
+multilib version of the gcc toolchain that can compile for native 32- and
+64-Bit Windows versions. It also comes with a working pthread implementation.
+
+The latest config and build scripts we use for MinGW have only be tested
+for the gcc-4.4 compiler toolchain (or better).
 
 Using MinGW is a pragmatic decision, it's the easiest way to port this
 heavily UNIX based sourcebase to native Windows. The goal is of course
@@ -49,7 +60,7 @@ Microsoft Development tools are in your PATH right after the MinGW
 tools. The LIB.EXE tool is the only one needed. You need this only if 
 you want to build DLLs that work with native Windows programs. If you 
 don't have any Microsoft  Development tools on your machine, consider 
-at least to get the free "Visual C++ 2008 Express Edition". 
+at least to get the free "Visual C++ 2010 Express Edition". 
 It contains the LIB.EXE tool. You may also use this compiler to test 
 writing native Windows programs using the ncurses DLLs without using 
 MinGW then for writing apps.
@@ -57,20 +68,48 @@ MinGW then for writing apps.
 Please unset the TERM environment variable, so that the Console driver
 gets activated.
 
+Please also make sure that MSYS links to the correct directory containing
+your MinGW toolchain. For TDM this is usually C:\MinGW64. In your Windows
+CMD.EXE command shell go to the MSYS root directory (most probably 
+C:\MSYS or C:\MSYS\1.0) and verify, that there is a junction point mingw
+that points to the MinGW toolchain directory. If not, delete the mingw
+directory and use the mklink command (or the linkd.exe utility on older
+Windows) to create the junction point.
+
 This code requires WindowsNT 5.1 or better, which means on the client
 Windows XP or better, on the server Windows Server 2003 or better.
 
-In order to build the DLLs, you must call
+In order to build ncurses for the planned interop layer with .NET, we
+recommend to use these options with configure
+
+         --disable-home-terminfo
+         --enable-reentrant
+         --enable-sp-funcs
+         --enable-term-driver
+         --enable-interop
+         --with-pthread         (if using TDM toolchain as recommended)
+
+This is the configuration commandline as I'm using it at the moment:
+
+./configure --prefix=/mingw --without-cxx-binding --without-ada --enable-warnings --enable-assertions --enable-reentrant --with-debug --with-normal --disable-home-terminfo --enable-sp-funcs --enable-term-driver --enable-interop --with-pthread
+
+
+All the options above are - like the whole Windows support -
+experimental.
+
+In order to build the DLLs, after your regular make you must call
 
    make dlls
 
+
 A lot is still TODO, e.g.:
 
   - Mouse support for the Console
   - Wide Character support
     The Win32Con driver should actually only use Unicode in the
     future.
-  - Thread support (locking)
+  - Thread support (locking). If using TDM toolchain this is done by
+    configuring pthreads.
   - A GUI console driver
   - Support for Terminals attached via a serial port (via terminfo)
   - Support for networked Terminal connections (via terminfo)
index 7da38f6beb266b33c0868524d2cb8af9cda03e2d..9c6b17d142db1827cb2039201f3a6c961c89454a 100755 (executable)
--- a/configure
+++ b/configure
@@ -1,5 +1,5 @@
 #! /bin/sh
-# From configure.in Revision: 1.507 .
+# From configure.in Revision: 1.509 .
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by Autoconf 2.52.20100814.
 #
@@ -19019,7 +19019,14 @@ else
        MAKE_TESTS="#"
 fi
 
-ac_config_files="$ac_config_files include/MKterm.h.awk include/curses.head:include/curses.h.in include/ncurses_dll.h include/termcap.h include/unctrl.h $SUB_MAKEFILES Makefile"
+SUB_SCRIPTS=
+case $cf_cv_system_name in #(vi
+*mingw32*) #(vi
+       SUB_SCRIPTS="mk-dlls.sh"
+       ;;
+esac
+
+ac_config_files="$ac_config_files include/MKterm.h.awk include/curses.head:include/curses.h.in include/ncurses_dll.h include/termcap.h include/unctrl.h $SUB_SCRIPTS $SUB_MAKEFILES Makefile"
 ac_config_commands="$ac_config_commands default"
 cat >confcache <<\_ACEOF
 # This file is a shell script that caches the results of configure
@@ -19100,7 +19107,7 @@ DEFS=-DHAVE_CONFIG_H
 : ${CONFIG_STATUS=./config.status}
 ac_clean_files_save=$ac_clean_files
 ac_clean_files="$ac_clean_files $CONFIG_STATUS"
-{ echo "$as_me:19103: creating $CONFIG_STATUS" >&5
+{ echo "$as_me:19110: creating $CONFIG_STATUS" >&5
 echo "$as_me: creating $CONFIG_STATUS" >&6;}
 cat >$CONFIG_STATUS <<_ACEOF
 #! $SHELL
@@ -19276,7 +19283,7 @@ cat >>$CONFIG_STATUS <<\EOF
     echo "$ac_cs_version"; exit 0 ;;
   --he | --h)
     # Conflict between --help and --header
-    { { echo "$as_me:19279: error: ambiguous option: $1
+    { { echo "$as_me:19286: error: ambiguous option: $1
 Try \`$0 --help' for more information." >&5
 echo "$as_me: error: ambiguous option: $1
 Try \`$0 --help' for more information." >&2;}
@@ -19295,7 +19302,7 @@ Try \`$0 --help' for more information." >&2;}
     ac_need_defaults=false;;
 
   # This is an error.
-  -*) { { echo "$as_me:19298: error: unrecognized option: $1
+  -*) { { echo "$as_me:19305: error: unrecognized option: $1
 Try \`$0 --help' for more information." >&5
 echo "$as_me: error: unrecognized option: $1
 Try \`$0 --help' for more information." >&2;}
   "include/ncurses_dll.h" ) CONFIG_FILES="$CONFIG_FILES include/ncurses_dll.h" ;;
   "include/termcap.h" ) CONFIG_FILES="$CONFIG_FILES include/termcap.h" ;;
   "include/unctrl.h" ) CONFIG_FILES="$CONFIG_FILES include/unctrl.h" ;;
+  "$SUB_SCRIPTS" ) CONFIG_FILES="$CONFIG_FILES $SUB_SCRIPTS" ;;
   "$SUB_MAKEFILES" ) CONFIG_FILES="$CONFIG_FILES $SUB_MAKEFILES" ;;
   "Makefile" ) CONFIG_FILES="$CONFIG_FILES Makefile" ;;
   "default" ) CONFIG_COMMANDS="$CONFIG_COMMANDS default" ;;
   "include/ncurses_cfg.h" ) CONFIG_HEADERS="$CONFIG_HEADERS include/ncurses_cfg.h:include/ncurses_cfg.hin" ;;
-  *) { { echo "$as_me:19403: error: invalid argument: $ac_config_target" >&5
+  *) { { echo "$as_me:19411: error: invalid argument: $ac_config_target" >&5
 echo "$as_me: error: invalid argument: $ac_config_target" >&2;}
    { (exit 1); exit 1; }; };;
   esac
@@ -19806,7 +19814,7 @@ done; }
   esac
 
   if test x"$ac_file" != x-; then
-    { echo "$as_me:19809: creating $ac_file" >&5
+    { echo "$as_me:19817: creating $ac_file" >&5
 echo "$as_me: creating $ac_file" >&6;}
     rm -f "$ac_file"
   fi
@@ -19824,7 +19832,7 @@ echo "$as_me: creating $ac_file" >&6;}
       -) echo $tmp/stdin ;;
       [\\/$]*)
          # Absolute (can't be DOS-style, as IFS=:)
-         test -f "$f" || { { echo "$as_me:19827: error: cannot find input file: $f" >&5
+         test -f "$f" || { { echo "$as_me:19835: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          echo $f;;
@@ -19837,7 +19845,7 @@ echo "$as_me: error: cannot find input file: $f" >&2;}
            echo $srcdir/$f
          else
            # /dev/null tree
-           { { echo "$as_me:19840: error: cannot find input file: $f" >&5
+           { { echo "$as_me:19848: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          fi;;
@@ -19903,7 +19911,7 @@ for ac_file in : $CONFIG_HEADERS; do test "x$ac_file" = x: && continue
   * )   ac_file_in=$ac_file.in ;;
   esac
 
-  test x"$ac_file" != x- && { echo "$as_me:19906: creating $ac_file" >&5
+  test x"$ac_file" != x- && { echo "$as_me:19914: creating $ac_file" >&5
 echo "$as_me: creating $ac_file" >&6;}
 
   # First look for the input files in the build tree, otherwise in the
@@ -19914,7 +19922,7 @@ echo "$as_me: creating $ac_file" >&6;}
       -) echo $tmp/stdin ;;
       [\\/$]*)
          # Absolute (can't be DOS-style, as IFS=:)
-         test -f "$f" || { { echo "$as_me:19917: error: cannot find input file: $f" >&5
+         test -f "$f" || { { echo "$as_me:19925: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          echo $f;;
@@ -19927,7 +19935,7 @@ echo "$as_me: error: cannot find input file: $f" >&2;}
            echo $srcdir/$f
          else
            # /dev/null tree
-           { { echo "$as_me:19930: error: cannot find input file: $f" >&5
+           { { echo "$as_me:19938: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          fi;;
@@ -19985,7 +19993,7 @@ cat >>$CONFIG_STATUS <<\EOF
   rm -f $tmp/in
   if test x"$ac_file" != x-; then
     if cmp -s $ac_file $tmp/config.h 2>/dev/null; then
-      { echo "$as_me:19988: $ac_file is unchanged" >&5
+      { echo "$as_me:19996: $ac_file is unchanged" >&5
 echo "$as_me: $ac_file is unchanged" >&6;}
     else
       ac_dir=`$as_expr X"$ac_file" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
index b1a8886487ee5005575a8c908a8a72ef6536009e..94cd449b328ba451a6c4643c0e90d36456ebc61d 100644 (file)
@@ -28,14 +28,14 @@ dnl***************************************************************************
 dnl
 dnl Author: Thomas E. Dickey 1995-on
 dnl
-dnl $Id: configure.in,v 1.507 2010/09/11 16:50:32 tom Exp $
+dnl $Id: configure.in,v 1.509 2010/09/25 22:32:53 tom Exp $
 dnl Process this file with autoconf to produce a configure script.
 dnl
 dnl See http://invisible-island.net/autoconf/ for additional information.
 dnl
 dnl ---------------------------------------------------------------------------
 AC_PREREQ(2.13.20020210)
-AC_REVISION($Revision: 1.507 $)
+AC_REVISION($Revision: 1.509 $)
 AC_INIT(ncurses/base/lib_initscr.c)
 AC_CONFIG_HEADER(include/ncurses_cfg.h:include/ncurses_cfg.hin)
 
@@ -1896,12 +1896,20 @@ else
 fi
 AC_SUBST(MAKE_TESTS)
 
+SUB_SCRIPTS=
+case $cf_cv_system_name in #(vi
+*mingw32*) #(vi
+       SUB_SCRIPTS="mk-dlls.sh"
+       ;;
+esac
+
 AC_OUTPUT( \
        include/MKterm.h.awk \
        include/curses.head:include/curses.h.in \
        include/ncurses_dll.h \
        include/termcap.h \
        include/unctrl.h \
+       $SUB_SCRIPTS \
        $SUB_MAKEFILES \
        Makefile,[
 if test "x$cf_with_tests" != xno ; then
diff --git a/dist.mk b/dist.mk
index 7dc0a50b5cdb55629c36b681343685bbc2b1748c..54e06d3635a318954743c879f6f38d096b552c24 100644 (file)
--- a/dist.mk
+++ b/dist.mk
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.774 2010/09/18 14:51:01 tom Exp $
+# $Id: dist.mk,v 1.775 2010/09/25 16:51:06 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@ SHELL = /bin/sh
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 7
-NCURSES_PATCH = 20100918
+NCURSES_PATCH = 20100925
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
index 4aa5e80aade592ec54792119324c083d65bd7e6e..8e8844a751efab078a0e914fa04ec2009bb7a997 100644 (file)
@@ -1,4 +1,4 @@
-# $Id: Makefile.in,v 1.38 2010/04/03 15:27:33 tom Exp $
+# $Id: Makefile.in,v 1.39 2010/09/25 22:16:12 juergen Exp $
 ##############################################################################
 # Copyright (c) 1998,2009,2010 Free Software Foundation, Inc.                #
 #                                                                            #
@@ -77,6 +77,7 @@ AUTO_SRC = \
        hashsize.h \
        ncurses_def.h \
        parametrized.h \
+       config.h \
        term.h
 
 ################################################################################
@@ -108,6 +109,10 @@ ncurses_def.h: $(srcdir)/ncurses_defs $(srcdir)/MKncurses_def.sh
 parametrized.h: $(TERMINFO_CAPS) $(srcdir)/MKparametrized.sh
        AWK=$(AWK) sh $(srcdir)/MKparametrized.sh $(TERMINFO_CAPS) >$@
 
+# This is required by pthread.h on MinGW
+config.h:
+       touch $@
+
 tags:
        $(CTAGS) *.[ch]
 
@@ -121,7 +126,7 @@ clean :: mostlyclean
        -rm -f $(AUTO_SRC)
 
 distclean :: clean
-       -rm -f Makefile $(CONFIG_SRC)
+       -rm -f Makefile $(CONFIG_SRC) config.h
 
 realclean :: distclean
 
index 4fc921ee5ae8372f4aa044a2ad8a18c2eb402183..32470034df3448e819a22a817e8ad911d70584e7 100644 (file)
  *                                                                          *
  ****************************************************************************/
 
-/* $Id: nc_mingw.h,v 1.2 2010/08/07 18:42:26 tom Exp $ */
+/* $Id: nc_mingw.h,v 1.3 2010/09/25 22:16:12 juergen Exp $ */
 
 #ifndef NC_MINGW_H
 #define NC_MINGW_H 1
 
-#define WINVER 0x0501
+#ifdef WINVER
+#  if WINVER < 0x0501
+#    error WINVER must at least be 0x0501
+#  endif  
+#else
+#  define WINVER 0x0501
+#endif
 #include <windows.h>
 
 #undef sleep
index 13bc9cc8c51b11c14191a4f1d6ded642848c98b3..7a7af229fe84d3d3a05f6f68cd9a012b03b9c148 100644 (file)
@@ -6,8 +6,8 @@
 # Report bugs and new terminal descriptions to
 #      bug-ncurses@gnu.org
 #
-#      $Revision: 1.368 $
-#      $Date: 2010/09/12 00:55:01 $
+#      $Revision: 1.369 $
+#      $Date: 2010/09/25 18:02:29 $
 #
 # The original header is preserved below for reference.  It is noted that there
 # is a "newer" version which differs in some cosmetic details (but actually
@@ -2883,7 +2883,7 @@ crt|crt-vt220|CRT 2.3 emulating VT220,
 # the default behavior -TD
 
 putty|PuTTY terminal emulator,
-       am, bce, bw, ccc, hs, mir, msgr, xenl, xon,
+       am, bce, bw, ccc, hs, mir, msgr, xenl, xon, XT,
        colors#8, it#8, ncv#22, pairs#64,
        acsc=``aaffggjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
        bel=^G, blink=\E[5m, bold=\E[1m, cbt=\E[Z, civis=\E[?25l,
@@ -3653,7 +3653,7 @@ xterm-bold|xterm terminal emulator (X11R6 Window System) standout w/bold,
 #  -- MATSUMOTO Shoji)
 # kterm implements acsc via built-in table of X Drawable's
 kterm|kterm kanji terminal emulator (X window system),
-       eslok, hs,
+       eslok, hs, XT,
        ncv@,
        acsc=``aajjkkllmmnnooppqqrrssttuuvvwwxx~~,
        csr=\E[%i%p1%d;%p2%dr, dsl=\E[?H, enacs=, fsl=\E[?F,
@@ -3677,7 +3677,7 @@ xterm1|xterm terminal emulator ignoring the alternate screen buffer,
 # The README's with the distribution also say that it supports SGR 21, 24, 25
 # and 27, but they are not present in the terminfo or termcap.
 color_xterm|cx|cx100|color_xterm color terminal emulator for X,
-       OTbs, am, km, mir, msgr, xenl,
+       OTbs, am, km, mir, msgr, xenl, XT,
        cols#80, it#8, lines#65, ncv@,
        acsc=``aaffggjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
        bel=^G, bold=\E[1m, clear=\E[H\E[2J, cr=^M,
@@ -3895,7 +3895,7 @@ kvt|KDE terminal,
 # different from xterm (and vt100's).  They have the same behavior in this
 # detail, but it is unclear which copies the other.
 konsole-base|KDE console window,
-       bce, km@, npc,
+       bce, km@, npc, XT,
        bel@, blink=\E[5m, civis=\E[?25l, cnorm=\E[?25h,
        ech=\E[%p1%dX, flash=\E[?5h$<100/>\E[?5l,
        hpa=\E[%i%p1%dG, indn=\E[%p1%dS, kbs=\177, kdch1@,
@@ -3968,7 +3968,7 @@ konsole-256color|KDE console window with xterm 256-colors,
 #      control/shift/alt       kf1 to kf12     \E[11;8~ to \E[24;8~
 #
 mlterm|multi lingual terminal emulator,
-       am, eslok, km, mc5i, mir, msgr, npc, xenl,
+       am, eslok, km, mc5i, mir, msgr, npc, xenl, XT,
        colors#8, cols#80, it#8, lines#24, pairs#64,
        acsc=00``aaffgghhjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
        bel=^G, bold=\E[1m, cbt=\E[Z, civis=\E[?25l,
@@ -4035,7 +4035,7 @@ mlterm-256color|mlterm 3.0 with xterm 256-colors,
 # removed dch/dch1 because they are inconsistent with bce/ech -TD
 # remove km as per tack test -TD
 rxvt-basic|rxvt terminal base (X Window System),
-       OTbs, am, bce, eo, mir, msgr, xenl, xon,
+       OTbs, am, bce, eo, mir, msgr, xenl, xon, XT,
        cols#80, it#8, lines#24,
        acsc=``aaffggjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
        bel=^G, blink=\E[5m, bold=\E[1m, civis=\E[?25l,
@@ -4189,6 +4189,7 @@ rxvt-16color|xterm with 16 colors like aixterm,
 # mrxvt is based on rxvt 2.7.11, but has by default XTERM_FKEYS defined, which
 # makes its function-keys different from other flavors of rxvt -TD
 mrxvt|multitabbed rxvt,
+       XT,
        kEND=\E[8;2~, kHOM=\E[7;2~, kcub1=\E[D, kcud1=\E[B,
        kcuf1=\E[C, kcuu1=\E[A, kend=\E[8~, khome=\E[7~,
        kEND3=\E[8;3~, kEND4=\E[8;4~, kEND5=\E[8;5~,
@@ -4211,7 +4212,7 @@ mrxvt-256color|multitabbed rxvt with 256 colors,
 # remove nonworking flash -TD
 # remove km as per tack test -TD
 Eterm|Eterm-color|Eterm with xterm-style color support (X Window System),
-       am, bce, bw, eo, mc5i, mir, msgr, xenl, xon,
+       am, bce, bw, eo, mc5i, mir, msgr, xenl, xon, XT,
        btns#5, cols#80, it#8, lines#24, lm#0, ncv@,
        acsc=``aaffggjjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~~,
        bel=^G, blink=\E[5m, bold=\E[1m, civis=\E[?25l,
@@ -4247,6 +4248,7 @@ Eterm-88color|Eterm with 88 colors,
 
 # Based on rxvt 2.4.8, it has a few differences in key bindings
 aterm|AfterStep terminal,
+       XT,
        kbs=\177, kf1=\EOP, kf2=\EOQ, kf3=\EOR, kf4=\EOS, use=rxvt,
 
 # xiterm  0.5-5.2
@@ -4766,7 +4768,7 @@ screen.teraterm|disable ncv in teraterm,
        use=screen+fkeys, use=screen,
 # Other terminals
 screen.rxvt|screen in rxvt,
-       bw,
+       bw, XT,
        cvvis@, flash@, kcub1=\EOD, kcud1=\EOB, kcuf1=\EOC,
        kcuu1=\EOA, use=screen+fkeys, use=vt100+enq,
        use=rxvt+pcfkeys, use=vt220+keypad, use=screen,
@@ -22278,6 +22280,11 @@ v3220|LANPAR Vision II model 3220/3221/3222,
 # 2010-09-11
 #      * reformat acsc strings to canonical format -TD
 #
+# 2010-09-25
+#      * add "XT" capability to entries for terminals that support both
+#        xterm-style mouse- and title-controls, for "screen" which
+#        special-cases TERM beginning with "xterm" or "rxvt" -TD
+#
 # The following sets edit modes for GNU EMACS.
 # Local Variables:
 # fill-prefix:"\t"
similarity index 88%
rename from mk-dlls.sh
rename to mk-dlls.sh.in
index 3c21008de2b2ef8ccf0178efb45d455d02e85593..da2f39ba8aefc9ab205ad3c3945056e3362baef0 100644 (file)
@@ -1,5 +1,5 @@
 #!/bin/sh
-# $Id: mk-dlls.sh,v 1.2 2010/01/30 19:23:49 tom Exp $
+# $Id: mk-dlls.sh.in,v 1.1 2010/09/25 22:29:49 juergen Exp $
 ##############################################################################
 # Copyright (c) 2008,2010 Free Software Foundation, Inc.                     #
 #                                                                            #
@@ -32,7 +32,7 @@
 #
 # Build DLLs on MinGW
 #
-gcc -v 2>&1 | grep specs | grep mingw
+LANG=en_US @CC@ -v 2>&1 | grep Target | grep mingw
 if [ $? -eq 1 ]; then
   echo "$0 requires a mingw environment" >&2
 else
@@ -47,18 +47,18 @@ else
           if [ -f libncurses${t}${m}.a ]; then
             f=libncurses${t}${m}.a
             g=`basename $f .a | cut -c 4-`
-            gi=libw${g}.a
+            gi=libw${g}.dll.a
             td=tmp-${g}
             rm -rf "${td}"
             mkdir "${td}"
             cd "${td}"
               ar x ../${f} `ar t ../${f}`
-              gcc $cf -o w${g}.dll -Wl,--out-implib,${gi} -Wl,--output-def,w${g}.def -Wl,$lf `ar t ../$f`
+              @CC@ $cf -o w${g}.dll -Wl,--out-implib,${gi} -Wl,--output-def,w${g}.def -Wl,$lf `ar t ../$f` @LIBS@
               lib //NOLOGO /MACHINE:i386 /DEF:w${g}.def
               rm -f `ar t ../$f`
               mv w${g}.dll ..
               mv w${g}.lib ..
-              mv libw${g}.a ..
+              mv ${gi} ..
             cd ..
             rm -rf "${td}"
 
@@ -68,17 +68,18 @@ else
               do
                 g=`basename $f .a | cut -c 4-`
                 td=tmp-${g}
+                gi2=libw${g}.dll.a
                 rm -rf "${td}"
                 mkdir "${td}"
                 echo $g
                 cd "${td}"
                   ar x ../$f `ar t ../$f`
-                  gcc $cf -o w${g}.dll -Wl,--out-implib,libw${g}.a -Wl,--output-def,w${g}.def -Wl,$lf `ar t ../$f` ../${gi}
+                  @CC@ $cf -o w${g}.dll -Wl,--out-implib,${gi2} -Wl,--output-def,w${g}.def -Wl,$lf `ar t ../$f` ../${gi} @LIBS@
                   lib //NOLOGO /MACHINE:i386 /DEF:w${g}.def
                   rm -f `ar t ../$f`
                   mv w${g}.dll ..
                   mv w${g}.lib ..
-                  mv libw${g}.a ..
+                  mv ${gi2} ..
                 cd ..
                 rm -rf "${td}"
               done
index 0dfc5aacac58f5235c06201524c3fae30b134cae..c1859b2ab7a161c51f45e8fca229f9d4b7b81be3 100644 (file)
@@ -47,7 +47,7 @@
 
 #include <ctype.h>
 
-MODULE_ID("$Id: lib_trace.c,v 1.74 2010/01/16 16:31:38 tom Exp $")
+MODULE_ID("$Id: lib_trace.c,v 1.75 2010/09/25 22:16:12 juergen Exp $")
 
 NCURSES_EXPORT_VAR(unsigned) _nc_tracing = 0; /* always define this */
 
@@ -184,7 +184,11 @@ _nc_va_tracef(const char *fmt, va_list ap)
 # if USE_WEAK_SYMBOLS
        if ((pthread_self))
 # endif
+#ifdef __MINGW32__
+           fprintf(TraceFP, "%#lx:", (long) (void *) pthread_self().p);
+#else
            fprintf(TraceFP, "%#lx:", (long) (void *) pthread_self());
+#endif
 #endif
        if (before || after) {
            int n;
index 11d4cb7c42918686217d712815bff2d09f280364..ef2f6cbc58c1bb3b9b9ad223dad1771285bfad82 100644 (file)
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 /*
- * $Id: rain.c,v 1.36 2010/05/01 19:12:26 tom Exp $
+ * $Id: rain.c,v 1.37 2010/09/25 22:16:12 juergen Exp $
  */
 #include <test.priv.h>
 
@@ -222,7 +222,11 @@ draw_drop(void *arg)
      * Find myself in the list of threads so we can count the number of loops.
      */
     for (mystats = 0; mystats < MAX_THREADS; ++mystats) {
+#ifdef __MINGW32__
+       if (drop_threads[mystats].myself.p == pthread_self().p)
+#else
        if (drop_threads[mystats].myself == pthread_self())
+#endif
            break;
     }